import numpy as np
import scipy.stats as ss

Y = [[5, 7, 6],
      [9, 8, 10],
      [6, 3, 3]]

a = len(Y)
N = len(Y[0])
print("a = %d"%a)
print("N = %d"%N)

Y = np.array(Y)
Yd = Y.mean(axis = 1)
print('Yd = ', Yd)

Ydd = Y.mean()
print('Ydd = ', Ydd)

SSA = ((Yd - Ydd) ** 2).sum() * N
print('SSA = ', SSA)

SSS_A =   0.0
for j in range(a):
    SSS_A += ((Y[j] - Yd[j]) ** 2).sum()
print('SSS_A = ', SSS_A)

SST = SSA + SSS_A
dfA = a - 1
dfS_A = a * (N - 1)
MSA = SSA / dfA
MSS_A = SSS_A / dfS_A
F = MSA / MSS_A
p = ss.f.cdf(F, dfA, dfS_A)
print()
print("%10s"%"Source", end = " ")
print("%12s"%"SS", end = " ")
print("%5s"%"df", end = " ")
print("%12s"%"MS", end = " ")
print("%12s"%"F")
print("%10s"%"A", "%12.3f"%SSA, "%5d"%dfA, "%12.3f"%MSA, "%12.3f"%F,
      "   p = %-10.5f"%(1.0 - p))
print("%10s"%"S/A", "%12.3f"%SSS_A, "%5d"%dfS_A, "%12.3f"%MSS_A)
print("%10s"%"Total", "%12.3f"%SST, "%5d"%(a * N - 1))

