import numpy as np
import scipy.stats as ss

Y = [[1, 3, 2],
     [5, 9, 7],
     [6, 12, 9]]

N = len(Y)
a = len(Y[0])
print("a = %d     N = %d"%(a, N))

Y = np.array(Y)

Yid = Y.mean(axis = 1)
print(Yid)

Ydj = Y.mean(axis = 0)
print(Ydj)

Ydd = Y.mean()
print(Ydd)

SS_A = ((Ydj - Ydd) ** 2).sum() * N
SS_S = ((Yid - Ydd) ** 2).sum() * a

SS_SA =  ((Y - np.array([Yid]).T - Ydj + Ydd) ** 2).sum()

SS_T = SS_A + SS_S + SS_SA
df_A = a - 1
df_S = N - 1
df_SA = (a - 1) * (N - 1)
MS_A = SS_A / df_A
MS_S = SS_S / df_S
MS_SA = SS_SA / df_SA
F = MS_A / MS_SA
p = ss.f.cdf(F, df_A, df_SA)
print()
print("%10s"%"Source", "%12s"%"SS", "%5s"%"df", "%12s"%"MS", "%12s"%"F")
print("%10s"%"S", "%12.3f"%SS_S, "%5d"%df_S, "%12.3f"%MS_S)
print("%10s"%"A", "%12.3f"%SS_A, "%5d"%df_A, "%12.3f"%MS_A, "%12.3f"%F,
      "   p = %-10.5f"%(1.0 - p))
print("%10s"%"SA", "%12.3f"%SS_SA, "%5d"%df_SA, "%12.3f"%MS_SA)



